Index: contrib/amd/include/am_defs.h
===================================================================
RCS file: /home/ncvs/src/contrib/amd/include/am_defs.h,v
retrieving revision 1.12
diff -u -r1.12 am_defs.h
--- contrib/amd/include/am_defs.h	2001/09/02 20:37:36	1.12
+++ contrib/amd/include/am_defs.h	2001/09/24 03:45:56
@@ -360,6 +360,7 @@
  * Actions to take if <sys/mbuf.h> exists.
  */
 #ifdef HAVE_SYS_MBUF_H
+# include <sys/mac.h>
 # include <sys/mbuf.h>
 /*
  * OSF4 (DU-4.0) defines m_next and m_data also in <sys/mount.h> so I must
@@ -446,6 +447,8 @@
  * Actions to take if <sys/ucred.h> exists.
  */
 #ifdef HAVE_SYS_UCRED_H
+/* XXX: need something more here */
+#include <sys/mac.h>
 # include <sys/ucred.h>
 #endif /* HAVE_SYS_UCRED_H */
 
Index: contrib/bind/bin/named/ns_main.c
===================================================================
RCS file: /home/ncvs/src/contrib/bind/bin/named/ns_main.c,v
retrieving revision 1.1.1.7
diff -u -r1.1.1.7 ns_main.c
--- contrib/bind/bin/named/ns_main.c	2001/07/30 16:51:26	1.1.1.7
+++ contrib/bind/bin/named/ns_main.c	2001/09/24 15:08:33
@@ -98,8 +98,6 @@
 #include <sys/un.h>
 #ifdef SVR4	/* XXX */
 # include <sys/sockio.h>
-#else
-# include <sys/mbuf.h>
 #endif
 
 #include <netinet/in.h>
Index: contrib/bind/bin/named/ns_signal.c
===================================================================
RCS file: /home/ncvs/src/contrib/bind/bin/named/ns_signal.c,v
retrieving revision 1.1.1.3
diff -u -r1.1.1.3 ns_signal.c
--- contrib/bind/bin/named/ns_signal.c	2000/10/31 12:35:29	1.1.1.3
+++ contrib/bind/bin/named/ns_signal.c	2001/09/24 15:03:32
@@ -86,8 +86,6 @@
 #include <sys/socket.h>
 #ifdef SVR4	/* XXX */
 # include <sys/sockio.h>
-#else
-# include <sys/mbuf.h>
 #endif
 
 #include <netinet/in.h>
Index: contrib/ipfilter/ipsend/sbpf.c
===================================================================
RCS file: /home/ncvs/src/contrib/ipfilter/ipsend/sbpf.c,v
retrieving revision 1.4
diff -u -r1.4 sbpf.c
--- contrib/ipfilter/ipsend/sbpf.c	2001/07/28 12:08:15	1.4
+++ contrib/ipfilter/ipsend/sbpf.c	2001/09/24 12:24:40
@@ -14,6 +14,7 @@
 #include <errno.h>
 #include <sys/types.h>
 #include <sys/param.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/time.h>
 #include <sys/timeb.h>
Index: contrib/sendmail/src/deliver.c
===================================================================
RCS file: /home/ncvs/src/contrib/sendmail/src/deliver.c,v
retrieving revision 1.1.1.9
diff -u -r1.1.1.9 deliver.c
--- contrib/sendmail/src/deliver.c	2001/08/01 01:33:23	1.1.1.9
+++ contrib/sendmail/src/deliver.c	2001/08/05 16:51:40
@@ -1967,7 +1967,7 @@
 				if (pwd != NULL)
 					(void) setusercontext(NULL,
 						pwd, pwd->pw_uid,
-						LOGIN_SETRESOURCES|LOGIN_SETPRIORITY);
+						LOGIN_SETRESOURCES|LOGIN_SETPRIORITY|LOGIN_SETLABEL);
 			}
 # endif /* HASSETUSERCONTEXT */
 
Index: etc/login.conf
===================================================================
RCS file: /home/ncvs/src/etc/login.conf,v
retrieving revision 1.43
diff -u -r1.43 login.conf
--- etc/login.conf	2001/09/11 07:01:47	1.43
+++ etc/login.conf	2001/09/19 02:15:28
@@ -36,7 +36,8 @@
 	:sbsize=unlimited:\
 	:priority=0:\
 	:ignoretime@:\
-	:umask=022:
+	:umask=022:\
+	:label=biba/low,mls/low,partition/none:
 
 
 #
@@ -64,6 +65,7 @@
 #       in preference to 'default'.
 root:\
 	:ignorenologin:\
+	:label=biba/high,mls/low,partition/none:\
 	:tc=default:
 
 #
Index: lib/libc/gen/getmntinfo.c
===================================================================
RCS file: /home/ncvs/src/lib/libc/gen/getmntinfo.c,v
retrieving revision 1.3
diff -u -r1.3 getmntinfo.c
--- lib/libc/gen/getmntinfo.c	2001/10/10 17:48:42	1.3
+++ lib/libc/gen/getmntinfo.c	2001/10/16 01:11:03
@@ -38,6 +38,7 @@
 #endif /* LIBC_SCCS and not lint */
 
 #include <sys/param.h>
+#include <sys/mac.h>
 #include <sys/ucred.h>
 #include <sys/mount.h>
 #include <stdlib.h>
Index: lib/libc/gen/getpeereid.c
===================================================================
RCS file: /home/ncvs/src/lib/libc/gen/getpeereid.c,v
retrieving revision 1.1
diff -u -r1.1 getpeereid.c
--- lib/libc/gen/getpeereid.c	2001/08/17 22:09:15	1.1
+++ lib/libc/gen/getpeereid.c	2001/09/23 15:11:20
@@ -31,6 +31,7 @@
 
 #include <sys/param.h>
 #include <sys/socket.h>
+#include <sys/mac.h>
 #include <sys/ucred.h>
 #include <sys/un.h>
 
Index: lib/libc/posix1e/Makefile.inc
===================================================================
RCS file: /home/ncvs/src/lib/libc/posix1e/Makefile.inc,v
retrieving revision 1.6
diff -u -r1.6 Makefile.inc
--- lib/libc/posix1e/Makefile.inc	2001/09/01 00:00:50	1.6
+++ lib/libc/posix1e/Makefile.inc	2001/09/09 02:17:41
@@ -32,7 +32,12 @@
 	cap_set_file.c			\
 	cap_set_flag.c			\
 	cap_set_proc.c			\
-	cap_text.c
+	cap_text.c			\
+	mac_constant.c			\
+	mac_free.c			\
+	mac_get.c			\
+	mac_set.c			\
+	mac_text.c
 
 .if ${LIB} == "c"
 
Index: lib/libc/posix1e/mac_constant.c
===================================================================
RCS file: mac_constant.c
diff -N mac_constant.c
--- /dev/null	Tue Oct 16 15:44:01 2001
+++ mac_constant.c	Sun Jun  3 10:07:26 2001
@@ -0,0 +1,21 @@
+#include <sys/types.h>
+#include <sys/mac.h>
+
+/*
+ * The following label defines "system high", used by the TrustedBSD
+ * userland Trusted Code Base (TCB).  It is assigned during the install
+ * process to TCB files, and used by privileged processes when setting
+ * rights on files that are part of the TCB (/etc/passwd and so on).
+ * Changing this label has serious consequences both in terms of
+ * propagation (recompile everything, make sure the kernel default
+ * label matches, etc), as well as security (changing this may break
+ * assumptions throughout the system).  Don't change it unless you
+ * know what you're doing.  Seriously.
+ */
+
+const struct mac mac_userland_system_high_label = {
+	{MAC_BIBA_TYPE_HIGH, 0},
+	{MAC_MLS_TYPE_LOW, 0},
+	{MAC_PARTITION_TYPE_NONE, 0}
+};
+
Index: lib/libc/posix1e/mac_free.c
===================================================================
RCS file: mac_free.c
diff -N mac_free.c
--- /dev/null	Tue Oct 16 15:44:01 2001
+++ mac_free.c	Sun Jun  3 10:07:26 2001
@@ -0,0 +1,12 @@
+#include <sys/types.h>
+#include <sys/mac.h>
+
+#include <stdlib.h>
+
+int
+mac_free(void *buf_p)
+{
+
+	free(buf_p);
+	return (0);
+}
Index: lib/libc/posix1e/mac_get.c
===================================================================
RCS file: mac_get.c
diff -N mac_get.c
--- /dev/null	Tue Oct 16 15:44:01 2001
+++ mac_get.c	Sun Jun  3 10:07:26 2001
@@ -0,0 +1,68 @@
+#include <sys/types.h>
+#include <sys/mac.h>
+
+#include <errno.h>
+#include <stdlib.h>
+
+mac_t
+mac_get_file(const char *path_p)
+{
+	struct mac *label;
+	int error;
+
+	label = (mac_t) malloc(sizeof(*label));
+	if (label == NULL) {
+		errno = ENOMEM;
+		return (NULL);
+	}
+
+	error = __mac_get_file(path_p, label);
+	if (error) {
+		mac_free(label);
+		return (NULL);
+	}
+
+	return (label);
+}
+
+mac_t
+mac_get_fd(int fd)
+{
+	struct mac *label;
+	int error;
+
+	label = (mac_t) malloc(sizeof(*label));
+	if (label == NULL) {
+		errno = ENOMEM;
+		return (NULL);
+	}
+
+	error = __mac_get_fd(fd, label);
+	if (error) {
+		mac_free(label);
+		return (NULL);
+	}
+
+	return (label);
+}
+
+mac_t
+mac_get_proc()
+{
+	struct mac *label;
+	int error;
+
+	label = (mac_t) malloc(sizeof(*label));
+	if (label == NULL) {
+		errno = ENOMEM;
+		return (NULL);
+	}
+
+	error = __mac_get_proc(label);
+	if (error) {
+		mac_free(label);
+		return (NULL);
+	}
+
+	return (label);
+}
Index: lib/libc/posix1e/mac_set.c
===================================================================
RCS file: mac_set.c
diff -N mac_set.c
--- /dev/null	Tue Oct 16 15:44:01 2001
+++ mac_set.c	Sun Jun  3 10:07:26 2001
@@ -0,0 +1,23 @@
+#include <sys/types.h>
+#include <sys/mac.h>
+
+int
+mac_set_file(const char *path_p, mac_t label)
+{
+
+	return (__mac_set_file(path_p, label));
+}
+
+int
+mac_set_fd(int fd, mac_t label)
+{
+
+	return (__mac_set_fd(fd, label));
+}
+
+int
+mac_set_proc(mac_t label)
+{
+
+	return (__mac_set_proc(label));
+}
Index: lib/libc/posix1e/mac_text.c
===================================================================
RCS file: mac_text.c
diff -N mac_text.c
--- /dev/null	Tue Oct 16 15:44:01 2001
+++ mac_text.c	Sun Jun  3 10:07:26 2001
@@ -0,0 +1,391 @@
+#include <sys/types.h>
+#include <sys/mac.h>
+
+#include <errno.h>
+#include <stdio.h>
+#include <string.h>
+
+/*
+ * POSIX.1e does not define a text format for MAC label string conversions.
+ * We use the following format:
+ * "policy/qualifier,..."
+ * Where:
+ *  policy can be one of "biba", "mls", "partition
+ *  type for "biba" can be "high", "low", "equal", or a numeric grade
+ *  type for "mls" can be "high", "low", "equal", of a numeric level
+ *  type for "partition" can be "none", "all", or a numeric partition
+ * All policies must be present, but may be in any order.
+ *
+ * Sample labels:
+ *   biba/high,mls/low,partition/none
+ *   biba/low,mls/low,partition/none
+ *   biba/low,mls/low,partition/3
+ *   biba/low,mls/3,partition/none
+ */
+
+/*
+ * XXX: Parsing code below assumes these next two constants will be
+ * character strings containing a single character.
+ */
+#define	STRING_SEP	","
+#define	STRING_ASSIGN	"/"
+
+#define	STRING_BIBA	"biba"
+#define	STRING_MLS	"mls"
+#define	STRING_PARTITION	"partition"
+static char *STRING_UNKNOWN = "unknown";
+
+static char *STRING_BIBA_HIGH = "high";
+static char *STRING_BIBA_LOW = "low";
+static char *STRING_BIBA_EQUAL = "equal";
+
+static char *STRING_MLS_HIGH = "high";
+static char *STRING_MLS_LOW = "low";
+static char *STRING_MLS_EQUAL = "equal";
+
+static char *STRING_PARTITION_NONE = "none";
+static char *STRING_PARTITION_ALL = "all";
+
+static int
+biba_string_to_label(char *string, struct mac_biba *label)
+{
+	char *local_string, *token, *next_token, *tmp;
+	int error = 0;
+
+	local_string = strdup(string);
+	if (local_string == NULL)
+		return (ENOMEM);
+
+	next_token = local_string;
+	token = strsep(&next_token, STRING_ASSIGN);
+
+	if (strcmp(token, STRING_BIBA) != 0) {
+		error = EINVAL;
+		goto exit1;
+	}
+
+	token = strsep(&next_token, STRING_ASSIGN);
+	if (token == NULL) {
+		error = EINVAL;
+		goto exit1;
+	}
+
+	label->mb_grade = 0;
+	if (strcmp(token, STRING_BIBA_HIGH) == 0)
+		label->mb_type = MAC_BIBA_TYPE_HIGH;
+	else if (strcmp(token, STRING_BIBA_LOW) == 0)
+		label->mb_type = MAC_BIBA_TYPE_LOW;
+	else if (strcmp(token, STRING_BIBA_EQUAL) == 0)
+		label->mb_type = MAC_BIBA_TYPE_EQUAL;
+	else {
+		/* Should be a numeric grade. */
+		/* XXX: Check range for strtoul. */
+		label->mb_type = MAC_BIBA_TYPE_GRADE;
+		label->mb_grade = strtoul(token, &tmp, 10);
+		if (*tmp != '\0')
+			error = EINVAL;
+	}
+
+	if (next_token != NULL)
+		error = EINVAL;
+
+exit1:
+	free(local_string);
+	return (error);
+}
+
+static char *
+biba_label_to_string(struct mac_biba label)
+{
+	char *buf;
+
+	switch (label.mb_type) {
+	case MAC_BIBA_TYPE_GRADE:
+		asprintf(&buf, "%s%s%hu", STRING_BIBA, STRING_ASSIGN,
+		    label.mb_grade);
+		break;
+	case MAC_BIBA_TYPE_LOW:
+		asprintf(&buf, "%s%s%s", STRING_BIBA, STRING_ASSIGN,
+		    STRING_BIBA_LOW);
+		break;
+	case MAC_BIBA_TYPE_HIGH:
+		asprintf(&buf, "%s%s%s", STRING_BIBA, STRING_ASSIGN,
+		    STRING_BIBA_HIGH);
+		break;
+	case MAC_BIBA_TYPE_EQUAL:
+		asprintf(&buf, "%s%s%s", STRING_BIBA, STRING_ASSIGN,
+		    STRING_BIBA_EQUAL);
+		break;
+	default:
+		asprintf(&buf, "%s%s%s", STRING_BIBA, STRING_ASSIGN,
+		    STRING_UNKNOWN);
+	}
+
+	return (buf);
+}
+
+static int
+mls_string_to_label(char *string, struct mac_mls *label)
+{
+	char *local_string, *token, *next_token, *tmp;
+	int error = 0;
+
+	local_string = strdup(string);
+	if (local_string == NULL)
+		return (ENOMEM);
+
+	next_token = local_string;
+	token = strsep(&next_token, STRING_ASSIGN);
+
+	if (strcmp(token, STRING_MLS) != 0) {
+		error = EINVAL;
+		goto exit1;
+	}
+
+	token = strsep(&next_token, STRING_ASSIGN);
+	if (token == NULL) {
+		error = EINVAL;
+		goto exit1;
+	}
+
+	label->mm_level = 0;
+	if (strcmp(token, STRING_MLS_HIGH) == 0)
+		label->mm_type = MAC_MLS_TYPE_HIGH;
+	else if (strcmp(token, STRING_MLS_LOW) == 0)
+		label->mm_type = MAC_MLS_TYPE_LOW;
+	else if (strcmp(token, STRING_MLS_EQUAL) == 0)
+		label->mm_type = MAC_MLS_TYPE_EQUAL;
+	else {
+		/* Should be a numeric level. */
+		/* XXX: Check range for strtoul. */
+		label->mm_type = MAC_MLS_TYPE_LEVEL;
+		label->mm_level = strtoul(token, &tmp, 10);
+		if (*tmp != '\0')
+			error = EINVAL;
+	}
+
+	if (next_token != NULL)
+		error = EINVAL;
+
+exit1:
+	free(local_string);
+	return (error);
+}
+
+static char *
+mls_label_to_string(struct mac_mls label)
+{
+	char *buf;
+
+	switch (label.mm_type) {
+	case MAC_MLS_TYPE_LEVEL:
+		asprintf(&buf, "%s%s%hu", STRING_MLS, STRING_ASSIGN,
+		    label.mm_level);
+		break;
+	case MAC_MLS_TYPE_LOW:
+		asprintf(&buf, "%s%s%s", STRING_MLS, STRING_ASSIGN,
+		    STRING_MLS_LOW);
+		break;
+	case MAC_MLS_TYPE_HIGH:
+		asprintf(&buf, "%s%s%s", STRING_MLS, STRING_ASSIGN,
+		    STRING_MLS_HIGH);
+		break;
+	case MAC_MLS_TYPE_EQUAL:
+		asprintf(&buf, "%s%s%s", STRING_MLS, STRING_ASSIGN,
+		    STRING_MLS_EQUAL);
+		break;
+	default:
+		asprintf(&buf, "%s:%s", STRING_MLS, STRING_ASSIGN,
+		    STRING_UNKNOWN);
+	}
+
+	return (buf);
+}
+
+static int
+partition_string_to_label(char *string, struct mac_partition *label)
+{
+	char *local_string, *token, *next_token, *tmp;
+	int error = 0;
+
+	local_string = strdup(string);
+	if (local_string == NULL)
+		return (ENOMEM);
+
+	next_token = local_string;
+	token = strsep(&next_token, STRING_ASSIGN);
+
+	if (strcmp(token, STRING_PARTITION) != 0) {
+		error = EINVAL;
+		goto exit1;
+	}
+
+	token = strsep(&next_token, STRING_ASSIGN);
+	if (token == NULL) {
+		error = EINVAL;
+		goto exit1;
+	}
+
+	label->mp_partition = 0;
+	if (strcmp(token, STRING_PARTITION_NONE) == 0)
+		label->mp_type = MAC_PARTITION_TYPE_NONE;
+	else if (strcmp(token, STRING_PARTITION_ALL) == 0)
+		label->mp_type = MAC_PARTITION_TYPE_ALL;
+	else {
+		/* Should be a numeric partition identifier. */
+		/* XXX: Should check range for strtoul. */
+		label->mp_type = MAC_PARTITION_TYPE_PARTITION;
+		label->mp_partition = strtoul(token, &tmp, 10);
+		if (*tmp != '\0')
+			error = EINVAL;
+	}
+
+	if (next_token != NULL)
+		error = EINVAL;
+
+exit1:
+	free(local_string);
+	return (error);
+}
+
+static char *
+partition_label_to_string(struct mac_partition label)
+{
+	char *buf;
+
+	switch (label.mp_type) {
+	case MAC_PARTITION_TYPE_PARTITION:
+		asprintf(&buf, "%s%s%hu", STRING_PARTITION, STRING_ASSIGN,
+		    label.mp_partition);
+		break;
+	case MAC_PARTITION_TYPE_ALL:
+		asprintf(&buf, "%s%s%s", STRING_PARTITION, STRING_ASSIGN,
+		    STRING_PARTITION_ALL);
+		break;
+	case MAC_PARTITION_TYPE_NONE:
+		asprintf(&buf, "%s%s%s", STRING_PARTITION, STRING_ASSIGN,
+		    STRING_PARTITION_NONE);
+		break;
+	default:
+		asprintf(&buf, "%s%s%s", STRING_PARTITION, STRING_ASSIGN,
+		    STRING_UNKNOWN);	
+	}
+
+	return (buf);
+}
+
+char *
+mac_to_text(struct mac *mac_p, size_t *len_p)
+{
+	char *biba, *mls, *partition;
+	char *buf;
+	int len;
+
+	biba = biba_label_to_string(mac_p->m_biba);
+	if (biba == NULL) {
+		errno = ENOMEM;
+		return (NULL);
+	}
+	mls = mls_label_to_string(mac_p->m_mls);
+	if (mls == NULL) {
+		errno = ENOMEM;
+		free(biba);
+		return (NULL);
+	}
+	partition = partition_label_to_string(mac_p->m_partition);
+	if (partition == NULL) {
+		errno = ENOMEM;
+		free(biba);
+		free(mls);
+		return (NULL);
+	}
+
+	len = asprintf(&buf, "%s%s%s%s%s", biba, STRING_SEP, mls, STRING_SEP,
+	    partition);
+
+	free(biba);
+	free(mls);
+	free(partition);
+
+	if (len != -1 && len_p != NULL)
+		*len_p = len;
+
+	return (buf);
+}
+
+struct mac *
+mac_from_text(const char *text_p)
+{
+	struct mac *label;
+	char *local_string, *next_token, *token, *tmp;
+	int biba_seen = 0, mls_seen = 0, partition_seen = 0;
+	int error;
+
+	/*
+	 * Parse into three assignments, determine which assignments
+	 * they are and recurse appropriately, and reject if there are
+	 * not the right assignments (or duplicates).
+	 */
+
+	label = (struct mac *) malloc(sizeof(*label));
+	if (label == NULL) {
+		errno = ENOMEM;
+		goto exit1;
+	}
+
+	local_string = strdup(text_p);
+	if (local_string == NULL) {
+		errno = ENOMEM;
+		goto exit2;
+	}
+
+	next_token = local_string;
+	while ((token = strsep(&next_token, STRING_SEP)) != NULL) {
+
+		if (strncmp(token, STRING_BIBA STRING_ASSIGN, strlen(
+		    STRING_BIBA STRING_ASSIGN)) == 0) {
+			error = biba_string_to_label(token, &label->m_biba);
+			if (error) {
+				errno = error;
+				goto exit2;
+			}
+			biba_seen++;
+		} else if (strncmp(token, STRING_MLS STRING_ASSIGN, strlen(
+		    STRING_MLS STRING_ASSIGN)) == 0) {
+			error = mls_string_to_label(token, &label->m_mls);
+			if (error) {
+				errno = error;
+				goto exit2;
+			}
+			mls_seen++;
+		} else if (strncmp(token, STRING_PARTITION STRING_ASSIGN,
+		    strlen(STRING_PARTITION STRING_ASSIGN)) == 0) {
+			error = partition_string_to_label(token,
+			    &label->m_partition);
+			if (error) {
+				errno = error;
+				goto exit2;
+			}
+			partition_seen++;
+		} else {
+			/* Unrecognized label type name. */
+			errno = EINVAL;
+			goto exit2;
+		}
+	}
+
+	if (biba_seen != 1 || mls_seen != 1 || partition_seen != 1) {
+		errno = EINVAL;
+		goto exit2;
+	}
+
+	/* Success. */
+	goto exit1;
+
+exit2:
+	free(label);
+	label = NULL;
+exit1:
+	free(local_string);
+	return (label);
+}
Index: lib/libcom_err/Makefile
===================================================================
RCS file: /home/ncvs/src/lib/libcom_err/Makefile,v
retrieving revision 1.12
diff -u -r1.12 Makefile
--- lib/libcom_err/Makefile	2001/03/27 17:26:58	1.12
+++ lib/libcom_err/Makefile	2001/06/11 23:23:00
@@ -3,7 +3,7 @@
 LIB=	com_err
 SRCS=	com_err.c error.c
 INCS=	${COM_ERRDIR}/com_err.h ${COM_ERRDIR}/com_right.h
-MAN=	com_err.3
+#MAN=	com_err.3
 COM_ERRDIR=	${.CURDIR}/../../contrib/com_err
 CFLAGS+=	-I${COM_ERRDIR}
 
Index: lib/libutil/login_cap.h
===================================================================
RCS file: /home/ncvs/src/lib/libutil/login_cap.h,v
retrieving revision 1.4
diff -u -r1.4 login_cap.h
--- lib/libutil/login_cap.h	2000/08/22 02:15:52	1.4
+++ lib/libutil/login_cap.h	2000/11/19 22:56:25
@@ -47,7 +47,8 @@
 #define LOGIN_SETUMASK		0x0020		/* set umask, obviously */
 #define LOGIN_SETUSER		0x0040		/* set user (via setuid) */
 #define LOGIN_SETENV		0x0080		/* set user environment */
-#define	LOGIN_SETALL		0x00ff		/* set everything */
+#define	LOGIN_SETLABEL		0x0100		/* set user MAC label */
+#define	LOGIN_SETALL		0x01ff		/* set everything */
 
 #define BI_AUTH		"authorize"		/* accepted authentication */
 #define BI_REJECT	"reject"		/* rejected authentication */
Index: lib/libutil/login_class.c
===================================================================
RCS file: /home/ncvs/src/lib/libutil/login_class.c,v
retrieving revision 1.16
diff -u -r1.16 login_class.c
--- lib/libutil/login_class.c	2001/09/30 22:35:07	1.16
+++ lib/libutil/login_class.c	2001/10/01 17:13:02
@@ -40,6 +40,7 @@
 #include <login_cap.h>
 #include <paths.h>
 #include <sys/rtprio.h>
+#include <sys/mac.h>
 
 
 static struct login_res {
@@ -317,6 +318,7 @@
 #ifndef __NETBSD_SYSCALLS
     struct rtprio rtp;
 #endif
+    int error;
 
     if (lc == NULL) {
 	if (pwd != NULL && (lc = login_getpwclass(pwd)) != NULL)
@@ -371,6 +373,44 @@
 		   (u_long)pwd->pw_gid);
 	    login_close(llc);
 	    return -1;
+	}
+    }
+
+    /* Setup the user's MAC label. */
+    if (flags & LOGIN_SETLABEL) {
+	char *label_string;
+	mac_t label;
+
+	/*
+	 * XXX: In the following code, there are a number of "fail open"
+	 * cases in which the process label will not be set.  The following
+	 * cases need to be addressed better:
+	 * - The login.conf file does not contain a label for the user.
+	 *   but the kernel supports labeling (how to test this case?)
+	 * - The login.conf file contains a syntactically semantically
+	 *   invalid label.
+	 * - The kernel does not have support for labels compiled in, but
+	 *   a label is defined.
+	 */
+	label_string = login_getcapstr(lc, "label", NULL, NULL);
+	if (label_string == NULL) {
+	    /* Leave label as is, warning, dangerous */
+	} else {
+	    label = mac_from_text(label_string);
+	    if (label == NULL) {
+		syslog(LOG_ERR, "mac_from_text(%s): %m",
+		    label_string);
+		return -1;
+	    }
+	    error = mac_set_proc(label);
+	    mac_free(label);
+	    if (error != 0 && errno == ENOSYS) {
+		syslog(LOG_WARNING, "mac_set_proc(%s): warning: %m",
+		    label_string);
+	    } else if (error != 0) {
+		syslog(LOG_ERR, "mac_set_proc(%s): error: %m", label_string);
+		return -1;
+	    }
 	}
     }
 
Index: libexec/ftpd/ftpd.c
===================================================================
RCS file: /home/ncvs/src/libexec/ftpd/ftpd.c,v
retrieving revision 1.86
diff -u -r1.86 ftpd.c
--- libexec/ftpd/ftpd.c	2001/10/12 13:16:34	1.86
+++ libexec/ftpd/ftpd.c	2001/10/14 15:21:47
@@ -1058,7 +1058,8 @@
 	pw = NULL;
 #ifdef	LOGIN_CAP
 	setusercontext(NULL, getpwuid(0), (uid_t)0,
-		       LOGIN_SETPRIORITY|LOGIN_SETRESOURCES|LOGIN_SETUMASK);
+		       LOGIN_SETPRIORITY|LOGIN_SETRESOURCES|LOGIN_SETUMASK|
+		       LOGIN_SETLABEL);
 #endif
 #ifdef USE_PAM
 	if ((e = pam_setcred(pamh, PAM_DELETE_CRED)) != PAM_SUCCESS)
@@ -1308,7 +1309,7 @@
 	}
 	setusercontext(lc, pw, (uid_t)0,
 		LOGIN_SETLOGIN|LOGIN_SETGROUP|LOGIN_SETPRIORITY|
-		LOGIN_SETRESOURCES|LOGIN_SETUMASK);
+		LOGIN_SETRESOURCES|LOGIN_SETUMASK|LOGIN_SETLABEL);
 #else
 	setlogin(pw->pw_name);
 	(void) initgroups(pw->pw_name, pw->pw_gid);
Index: sbin/ipfw/ipfw.c
===================================================================
RCS file: /home/ncvs/src/sbin/ipfw/ipfw.c,v
retrieving revision 1.111
diff -u -r1.111 ipfw.c
--- sbin/ipfw/ipfw.c	2001/09/27 23:44:27	1.111
+++ sbin/ipfw/ipfw.c	2001/10/01 17:14:10
@@ -25,6 +25,7 @@
 
 
 #include <sys/param.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/sockio.h>
Index: sys/coda/coda_fbsd.c
===================================================================
RCS file: /home/ncvs/src/sys/coda/coda_fbsd.c,v
retrieving revision 1.24
diff -u -r1.24 coda_fbsd.c
--- sys/coda/coda_fbsd.c	2001/06/15 00:02:27	1.24
+++ sys/coda/coda_fbsd.c	2001/08/05 17:01:30
@@ -40,6 +40,7 @@
 #include <sys/kernel.h>
 #include <sys/lock.h>
 #include <sys/malloc.h>
+#include <sys/mac.h>
 #include <sys/ucred.h>
 #include <sys/vnode.h>
 
Index: sys/coda/coda_namecache.c
===================================================================
RCS file: /home/ncvs/src/sys/coda/coda_namecache.c,v
retrieving revision 1.14
diff -u -r1.14 coda_namecache.c
--- sys/coda/coda_namecache.c	2001/10/11 23:38:13	1.14
+++ sys/coda/coda_namecache.c	2001/10/14 15:24:28
@@ -82,6 +82,7 @@
 #include <sys/lock.h>
 #include <sys/malloc.h>
 #include <sys/mutex.h>
+#include <sys/mac.h>
 #include <sys/ucred.h>
 
 #include <vm/vm.h>
Index: sys/conf/files
===================================================================
RCS file: /home/ncvs/src/sys/conf/files,v
retrieving revision 1.574
diff -u -r1.574 files
--- sys/conf/files	2001/10/07 20:08:36	1.574
+++ sys/conf/files	2001/10/08 02:02:58
@@ -773,6 +773,10 @@
 kern/kern_linker.c	standard
 kern/kern_lock.c	standard
 kern/kern_lockf.c	standard
+kern/kern_mac.c		standard
+kern/kern_mac_biba.c	standard
+kern/kern_mac_mls.c	standard
+kern/kern_mac_partition.c	standard
 kern/kern_malloc.c	standard
 kern/kern_mib.c		standard
 kern/kern_module.c	standard
Index: sys/conf/newvers.sh
===================================================================
RCS file: /home/ncvs/src/sys/conf/newvers.sh,v
retrieving revision 1.47
diff -u -r1.47 newvers.sh
--- sys/conf/newvers.sh	2001/03/02 16:52:13	1.47
+++ sys/conf/newvers.sh	2001/05/31 14:41:23
@@ -34,7 +34,7 @@
 #	@(#)newvers.sh	8.1 (Berkeley) 4/20/94
 # $FreeBSD: src/sys/conf/newvers.sh,v 1.47 2001/03/02 16:52:13 ru Exp $
 
-TYPE="FreeBSD"
+TYPE="TrustedBSD"
 REVISION="5.0"
 BRANCH="CURRENT"
 RELEASE="${REVISION}-${BRANCH}"
Index: sys/conf/options
===================================================================
RCS file: /home/ncvs/src/sys/conf/options,v
retrieving revision 1.296
diff -u -r1.296 options
--- sys/conf/options	2001/10/10 23:06:52	1.296
+++ sys/conf/options	2001/10/11 14:37:34
@@ -107,6 +107,7 @@
 
 # TrustedBSD and POSIX.1e Kernel Options
 CAPABILITIES	opt_cap.h
+MAC		opt_mac.h
 
 # Do we want the config file compiled into the kernel?
 INCLUDE_CONFIG_FILE	opt_config.h
Index: sys/contrib/dev/oltr/if_oltr.c
===================================================================
RCS file: /home/ncvs/src/sys/contrib/dev/oltr/if_oltr.c,v
retrieving revision 1.20
diff -u -r1.20 if_oltr.c
--- sys/contrib/dev/oltr/if_oltr.c	2001/06/14 15:08:40	1.20
+++ sys/contrib/dev/oltr/if_oltr.c	2001/09/25 12:34:08
@@ -36,6 +36,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/malloc.h>
 #include <sys/kernel.h>
Index: sys/contrib/ipfilter/netinet/fil.c
===================================================================
RCS file: /home/ncvs/src/sys/contrib/ipfilter/netinet/fil.c,v
retrieving revision 1.25
diff -u -r1.25 fil.c
--- sys/contrib/ipfilter/netinet/fil.c	2001/09/12 22:06:36	1.25
+++ sys/contrib/ipfilter/netinet/fil.c	2001/09/24 11:58:57
@@ -37,6 +37,7 @@
 #include <sys/uio.h>
 #if !defined(__SVR4) && !defined(__svr4__)
 # ifndef linux
+#  include <sys/mac.h>
 #  include <sys/mbuf.h>
 # endif
 #else
Index: sys/contrib/ipfilter/netinet/ip_auth.c
===================================================================
RCS file: /home/ncvs/src/sys/contrib/ipfilter/netinet/ip_auth.c,v
retrieving revision 1.22
diff -u -r1.22 ip_auth.c
--- sys/contrib/ipfilter/netinet/ip_auth.c	2001/07/28 11:58:25	1.22
+++ sys/contrib/ipfilter/netinet/ip_auth.c	2001/09/24 11:58:01
@@ -29,6 +29,7 @@
 #endif
 #if !defined(__SVR4) && !defined(__svr4__)
 # ifndef linux
+#  include <sys/mac.h>
 #  include <sys/mbuf.h>
 # endif
 #else
Index: sys/contrib/ipfilter/netinet/ip_fil.c
===================================================================
RCS file: /home/ncvs/src/sys/contrib/ipfilter/netinet/ip_fil.c,v
retrieving revision 1.27
diff -u -r1.27 ip_fil.c
--- sys/contrib/ipfilter/netinet/ip_fil.c	2001/09/12 08:37:00	1.27
+++ sys/contrib/ipfilter/netinet/ip_fil.c	2001/09/24 11:58:07
@@ -52,6 +52,7 @@
 # else
 #  include <sys/dir.h>
 # endif
+# include <sys/mac.h>
 # include <sys/mbuf.h>
 #else
 # include <sys/filio.h>
Index: sys/contrib/ipfilter/netinet/ip_frag.c
===================================================================
RCS file: /home/ncvs/src/sys/contrib/ipfilter/netinet/ip_frag.c,v
retrieving revision 1.17
diff -u -r1.17 ip_frag.c
--- sys/contrib/ipfilter/netinet/ip_frag.c	2001/07/30 10:53:23	1.17
+++ sys/contrib/ipfilter/netinet/ip_frag.c	2001/09/24 11:58:14
@@ -36,6 +36,7 @@
 #  include <sys/kernel.h>
 # endif
 # ifndef linux
+#  include <sys/mac.h>
 #  include <sys/mbuf.h>
 # endif
 #else
Index: sys/contrib/ipfilter/netinet/ip_log.c
===================================================================
RCS file: /home/ncvs/src/sys/contrib/ipfilter/netinet/ip_log.c,v
retrieving revision 1.18
diff -u -r1.18 ip_log.c
--- sys/contrib/ipfilter/netinet/ip_log.c	2001/07/28 11:58:26	1.18
+++ sys/contrib/ipfilter/netinet/ip_log.c	2001/09/24 11:58:23
@@ -65,6 +65,7 @@
 #  else
 #   include <sys/dir.h>
 #  endif
+#  include <sys/mac.h>
 #  include <sys/mbuf.h>
 # else
 #  include <sys/filio.h>
Index: sys/contrib/ipfilter/netinet/ip_nat.c
===================================================================
RCS file: /home/ncvs/src/sys/contrib/ipfilter/netinet/ip_nat.c,v
retrieving revision 1.23
diff -u -r1.23 ip_nat.c
--- sys/contrib/ipfilter/netinet/ip_nat.c	2001/07/28 11:58:26	1.23
+++ sys/contrib/ipfilter/netinet/ip_nat.c	2001/09/24 11:58:29
@@ -41,6 +41,7 @@
 #endif
 #if !defined(__SVR4) && !defined(__svr4__)
 # ifndef linux
+#  include <sys/mac.h>
 #  include <sys/mbuf.h>
 # endif
 #else
Index: sys/contrib/ipfilter/netinet/ip_proxy.c
===================================================================
RCS file: /home/ncvs/src/sys/contrib/ipfilter/netinet/ip_proxy.c,v
retrieving revision 1.12
diff -u -r1.12 ip_proxy.c
--- sys/contrib/ipfilter/netinet/ip_proxy.c	2001/07/28 11:58:26	1.12
+++ sys/contrib/ipfilter/netinet/ip_proxy.c	2001/09/24 11:58:35
@@ -36,6 +36,7 @@
 #endif
 #if !defined(__SVR4) && !defined(__svr4__)
 # ifndef linux
+#  include <sys/mac.h>
 #  include <sys/mbuf.h>
 # endif
 #else
Index: sys/contrib/ipfilter/netinet/ip_state.c
===================================================================
RCS file: /home/ncvs/src/sys/contrib/ipfilter/netinet/ip_state.c,v
retrieving revision 1.22
diff -u -r1.22 ip_state.c
--- sys/contrib/ipfilter/netinet/ip_state.c	2001/07/28 11:58:26	1.22
+++ sys/contrib/ipfilter/netinet/ip_state.c	2001/09/24 11:58:44
@@ -46,6 +46,7 @@
 #endif
 #if !defined(__SVR4) && !defined(__svr4__)
 # ifndef linux
+#  include <sys/mac.h>
 #  include <sys/mbuf.h>
 # endif
 #else
Index: sys/dev/an/if_an.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/an/if_an.c,v
retrieving revision 1.24
diff -u -r1.24 if_an.c
--- sys/dev/an/if_an.c	2001/10/11 17:52:19	1.24
+++ sys/dev/an/if_an.c	2001/10/14 15:24:48
@@ -93,6 +93,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/proc.h>
 #include <sys/kernel.h>
Index: sys/dev/an/if_an_isa.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/an/if_an_isa.c,v
retrieving revision 1.6
diff -u -r1.6 if_an_isa.c
--- sys/dev/an/if_an_isa.c	2001/09/10 02:36:18	1.6
+++ sys/dev/an/if_an_isa.c	2001/09/24 17:58:02
@@ -41,6 +41,7 @@
  */
 
 #include "opt_inet.h"
+
 #ifdef INET
 #define ANCACHE
 #endif
@@ -48,6 +49,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/kernel.h>
 #include <sys/socket.h>
Index: sys/dev/an/if_an_pci.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/an/if_an_pci.c,v
retrieving revision 1.12
diff -u -r1.12 if_an_pci.c
--- sys/dev/an/if_an_pci.c	2001/10/11 17:52:19	1.12
+++ sys/dev/an/if_an_pci.c	2001/10/14 15:24:48
@@ -61,6 +61,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/sockio.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/kernel.h>
 #include <sys/socket.h>
Index: sys/dev/ar/if_ar.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/ar/if_ar.c,v
retrieving revision 1.50
diff -u -r1.50 if_ar.c
--- sys/dev/ar/if_ar.c	2001/04/16 13:20:21	1.50
+++ sys/dev/ar/if_ar.c	2001/09/25 11:38:33
@@ -50,6 +50,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kernel.h>
+#include <sys/mac.h>
 #include <sys/malloc.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
Index: sys/dev/awi/awi.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/awi/awi.c,v
retrieving revision 1.16
diff -u -r1.16 awi.c
--- sys/dev/awi/awi.c	2001/09/12 08:37:02	1.16
+++ sys/dev/awi/awi.c	2001/09/24 17:58:11
@@ -98,6 +98,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kernel.h>
+#include <sys/mac.h>
 #include <sys/mbuf.h>
 #include <sys/proc.h>
 #include <sys/malloc.h>
